/****************************************************************************
    LCoV library editor for BSch3V
    Copyright (C) 2004-2014 H.Okada (http://www.suigyodo.com/online)
*****************************************************************************/

#pragma once
#include "sptnobj.h"

#define VECTPLOYGON_MAXNODE 32	//p`̍ő咸_

class SPtnObjPolygon :
	public SPtnObj
{
public:
	SPtnObjPolygon(void);
	~SPtnObjPolygon(void);
	int id(){return VECTPTN_PG;}
	SPtnObjPolygon(const SPtnObjPolygon&);					//Rs[RXgN^
	SPtnObjPolygon& operator=(const SPtnObjPolygon&);		//Zq
	SPtnObj* duplicate();							//
	bool qValid();									//Lȃf[^ǂԂB

	//_̂ƂugripvƂĂB
	//GUIł̑z肵gripłǂȂǓK؂ȂȁB
	//Obv̐Ԃ
	int gripCount(){return m_nCount;}
	//Obv̈ʒuԂ
	SPoint gripPos(int grip);
	//Obv̈ʒu𓮂
	void setGripPos(int grip,int x,int y);
	//_̒ǉ
	void addGrip(int index,int x,int y);

	void move(int offsetx,int offsety);				//ʒu𓮂
	void mirrorH(int x); 							//XWw肵čE]s
	void mirrorH();									//E]s
	void rotate(const SPoint& p);					//XYSWw肵āA]s
	void rotate();									//]s
	bool testIntersect(const SRect& );				//͈͂w肵đI`FbNs
	bool testIntersect(const SPoint& );				//_w肵đI`FbNs
	SRect area();									//L͈͂Ԃ
	bool readCe3(SReadCE3& rce3);
	bool writeCe3(SWriteCE3& wce3,SPoint* pOrigin=NULL);
public:
	int	    m_nCount;		//_̐
	SPoint* m_pPt;			//_W
	//int m_nFill;
protected:
	void normalize();
};
