/****************************************************************************
    BSch3V schematic capture
    Copyright (C) 1997-2014 H.Okada
*****************************************************************************/

/****************************************************************************
** XBSch}ʗvfGg[NX
****************************************************************************/
#ifndef XBSCHENTRY_H
#define XBSCHENTRY_H

#include "xbsch.h"
#include "xbschobj.h"
#include "xbschline.h"


class SXBSchEntry:public SXBSchLine
{
public:
	enum ENTRY_ASPECT
	{
		RIGHT_DOWN=0,
		LEFT_DOWN
	};
protected:
	//m_p1  m_p2̉ɂȂ悤ɐݒ肷B
	void normalize();
public:
	//RXgN^
	SXBSchEntry();
	//fXgN^
	virtual ~SXBSchEntry(){};
/*
	//Xg[̓ǂݍ ` -ENTRY
	bool readStream(SCsvIStream* pStrm,const SPoint* pptOrigin);
	//Xg[ւ̏݁@+ENTRY ` -ENTRY
	bool writeStream(SCsvOStream* pStrm,const SPoint* pptOrigin);
*/
	bool readCe3(SReadCE3&,const SPoint* ,SXBSchDoc*);
	bool writeCe3(SWriteCE3& ,const SPoint* );


	//ID̎擾
	unsigned id(){return ID_ENTRY;}
	unsigned objectFilterValue(){return OBJMASK_WENTRY;} 
public:
	//s
	SXBSchObj* duplicate();
	//W̐ݒ  
	//m_p1ւ̐ݒsm_p2ւ̐ݒB
	void setX1(int);
	void setY1(int);
	void setP1(const SPoint&);
	//m_p2ւ̐ݒ𖳌ɂĂ
	void setX2(int){}
	void setY2(int){}
	void setP2(const SPoint&){}
	//͈͂IăhbOIs
	unsigned testSelectionForDrag(const SRect& rc){return testSelection(rc);} 
	//Gg[̉EA擾
	unsigned aspect();
	//Gg[̉EAݒ肷
	void setAspect(int aspect);
};


class SXBSchBusEntry:public SXBSchEntry
{
public:
	//RXgN^
	SXBSchBusEntry(){}
	//fXgN^
	virtual ~SXBSchBusEntry(){}
/*
	//Xg[̓ǂݍ ` -BENTRY
	bool readStream(SCsvIStream* pStrm,const SPoint* pptOrigin);
	//Xg[ւ̏݁@+BENTRY ` -BENTRY
	bool writeStream(SCsvOStream* pStrm,const SPoint* pptOrigin);
*/
	bool readCe3(SReadCE3&,const SPoint* ,SXBSchDoc*);
	bool writeCe3(SWriteCE3& ,const SPoint* );

	//ID̎擾
	unsigned id(){return ID_BENTRY;}
	unsigned objectFilterValue(){return OBJMASK_BENTRY;} 
public:
	//s
	SXBSchObj* duplicate();
};

#endif
