/****************************************************************************
    BSch3V schematic capture
    Copyright (C) 1997-2014 H.Okada
*****************************************************************************/

// PartAtrb.h : wb_[ t@C
//
#ifndef PARTATRB_H
#define PARTATRB_H

#include "complib.h"
#include "afxwin.h"

/////////////////////////////////////////////////////////////////////////////
// CPartAtrb _CAO

class CPartAtrb : public CDialog
{
// RXgNV
public:
	CPartAtrb(CWnd* pParent = NULL);   // W̃RXgN^
// _CAO f[^
	//{{AFX_DATA(CPartAtrb)
	enum { IDD = IDD_ATRIB_PART };
	CString	m_rPartName;
	CString	m_rPartNum;
	CString m_rNote;
	//}}AFX_DATA
	int		m_nBlock;
	int		m_nBlockMin;       //RXgN^łPɏ
	int		m_nBlockMax;
	CString m_rOrgName;
	const SCompIndex* m_pPartIndex;
	int m_nLastSelectPart;
	int m_nLastSelectLibrary;
	BOOL m_modifiedCompInfo;	   //RXgN^FALSEɏ

// I[o[Ch
	// ClassWizard ͉z֐𐶐I[o[Ch܂B
	//{{AFX_VIRTUAL(CPartAtrb)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CPartAtrb)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	afx_msg void OnChangeEditPartblock();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	//IDC_PIN_NUM X^eBbNRg[ɃsԍZbg
	void SetBlockPins(int nBlock);

	TCHAR m_szLcoPath[_MAX_PATH];
	BOOL m_enableEditComp;
	//SCompIndex* m_pTempPartIndex;
	SCompLib m_tempLib;		//LCoVŕҏWƂɎgB̃_CAONXł܂Ŏ̂Ȃ悤ɃNXϐƂĐ錾B

public:
	afx_msg void OnBnClickedReplaceCompindex();
	afx_msg void OnBnClickedEditCompindex();

	BOOL m_bNameVertical;
	BOOL m_bNumVertical;
	
	CString m_mfr;
	CString m_mfrpnum;
	CString m_package;

	int m_nFocusedTo;

	

	BOOL m_bHideNum;
	BOOL m_bHideVal;
};

#endif